"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const load_1 = require("./load");
const RedprintError_1 = require("./RedprintError");
class Validator {
    constructor() {
        this.validate = (key, input) => {
            const redprint = load_1.load();
            // validate key
            if (!key.match(/\w+\.\w+/))
                throw new Error('Invalid key');
            const attribute = _.get(redprint, key);
            _.each(attribute, (validation, validationName) => {
                if (!eval(validation)(input))
                    // RedError design
                    throw new RedprintError_1.RedprintError(input, key, validationName);
            });
            return true;
        };
    }
}
exports.validate = new Validator().validate;
//# sourceMappingURL=index.js.map